var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx } from "react/jsx-runtime";
import * as React from 'react';
import RcSlider, { Range as RcRange, Handle as RcHandle } from 'rc-slider';
import SliderTooltip from "./SliderTooltip";
import classNames from 'classnames';
import "./style/slider.css";
var prefixCls = 'dmc-slider';
export var Slider = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _a, _b;

  var _c = React.useState({}),
      visibles = _c[0],
      setVisibles = _c[1];

  var toggleTooltipVisible = function toggleTooltipVisible(index, visible) {
    var temp = __assign({}, visibles);

    temp[index] = visible;
    setVisibles(temp);
  };

  var handleWithTooltip = function handleWithTooltip(_a) {
    var prefixCls = _a.prefixCls,
        _b = _a.info,
        value = _b.value,
        dragging = _b.dragging,
        index = _b.index,
        restProps = __rest(_b, ["value", "dragging", "index"]);

    var tipFormatter = props.tipFormatter,
        tooltipVisible = props.tooltipVisible,
        tooltipPlacement = props.tooltipPlacement,
        getTooltipPopupContainer = props.getTooltipPopupContainer,
        vertical = props.vertical;
    var isTipFormatter = tipFormatter ? visibles[index] || dragging : false;
    var visible = tooltipVisible || tooltipVisible === undefined && isTipFormatter;
    return _jsx(SliderTooltip, __assign({
      title: tipFormatter ? tipFormatter(value) : '',
      visible: visible,
      placement: tooltipPlacement || (vertical ? 'right' : 'top'),
      overlayClassName: prefixCls + "-tooltip",
      getPopupContainer: getTooltipPopupContainer || function () {
        return document.body;
      }
    }, {
      children: _jsx(RcHandle, __assign({}, restProps, {
        value: value,
        onMouseEnter: function onMouseEnter() {
          return toggleTooltipVisible(index, true);
        },
        onMouseLeave: function onMouseLeave() {
          return toggleTooltipVisible(index, false);
        }
      }), void 0)
    }), index);
  };

  var range = props.range,
      className = props.className,
      size = props.size,
      restProps = __rest(props, ["range", "className", "size"]);

  if (range) {
    return _jsx(RcRange, __assign({}, restProps, {
      className: classNames(className, (_a = {}, _a[prefixCls + "-" + size] = size, _a)),
      ref: ref,
      prefixCls: prefixCls,
      handle: function handle(info) {
        return handleWithTooltip({
          prefixCls: prefixCls,
          info: info
        });
      }
    }), void 0);
  }

  return _jsx(RcSlider, __assign({}, restProps, {
    className: classNames(className, (_b = {}, _b[prefixCls + "-" + size] = size, _b)),
    ref: ref,
    prefixCls: prefixCls,
    handle: function handle(info) {
      return handleWithTooltip({
        prefixCls: prefixCls,
        info: info
      });
    }
  }), void 0);
});
Slider.displayName = 'Slider';
Slider.defaultProps = {
  tipFormatter: function tipFormatter(value) {
    return typeof value === 'number' ? value.toString() : '';
  }
};
export default Slider;
var SliderMemo = /*#__PURE__*/React.memo(Slider);
SliderMemo.displayName = 'SliderMemo';
export { SliderMemo };

